from __future__ import with_statement
print "b428"
os.chdir("/home/was/edu/2007/bsd/sage_notebook/worksheets/kolyconjmod/cells/2")
ms = ModularSymbols
ec = EllipticCurve


#x = polygen(QQ,'x')

#auto
def qflist(D, N, b):
    b = ZZ(b)
    R = ZZ((b**Integer(2) - D)/(Integer(4)*N))
    L = []
    Lprime = []
    for d in divisors(R):
       fqf = BinaryQF([d*N,b,R/d])
       fr = fqf.reduce()
       if not fr in Lprime:
           Lprime.append(fr)
           L.append(fqf)
    return L

def tau(f):
   A,B,C = f
   D = f.discriminant()
   return (-B + sqrt(D))/(Integer(2)*A)

def phi(E, k, z, prec):
    """
    Map a point z in the upper half plan to a point on the complex torus
    representation of the elliptic curve, using prec terms of the
    modular parametrization.
    """
    b = exp(Integer(2)*pi*I*z)
    q = k(b)
    a = E.anlist(prec)
    return sum( k(a[n]/n) * q**n for n in xrange(Integer(1),prec))

def topoint(E, k, z):
    """
    Given a point in the complex lattice representation of E, return
    a point on the Weierstrass model of E.
    """
    E2 = E.change_ring(k)
    gp.set_real_precision(k.prec()+Integer(10))
    e = gp(E2)
    w = list(e.ellztopoint(z))
    k = E2.base_field()
    return E2.point([k(repr(w[Integer(0)])), k(repr(w[Integer(1)])), k(Integer(1))], check=False)

def compute_y(E, FD, lam, prec_field=Integer(100), prec_ser=Integer(1000)):
    N = E.conductor()
    D = FD * lam**Integer(2)
    srs = Mod(D, Integer(4)*N).sqrt(all=True)
    S = list(set([Mod(a, Integer(2)*N) for a in srs]))
    L = sum([qflist(D, N, b) for b in S], [])
    best = min([qf[Integer(1)] for qf in L])
    for qf in L:
        if qf[Integer(1)] == best:
           break
    z = tau(qf)
    print z
    k = ComplexField(prec_field)
    y_lattice_point = phi(E, k, z, prec_ser)
    y = topoint(E, k, y_lattice_point)
    return y

def Lambda1(E, ell, bnd):
    v = []
    p = Integer(3)
    while len(v) < bnd:
        if valuation(gcd(p+Integer(1), E.ap(p)), ell) >= Integer(1):
            v.append(p)
        p = next_prime(p)
    return v

print "e428"
